#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll det(ll x1, ll y1, ll x2, ll y2){
    return x1*y2 - x2*y1;
}

int main(int argc, char**argv){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
ll n; cin >> n;
ll x[n], y[n];
for ( int i = 0; i < n; i++ ){
    cin >> x[i] >> y[i];
}
ll povrsina;
for( int i = 0; i < n-1; i++ ){
    povrsina += 0.5 * (det(x[i], x[i+1], y[i], y[i+1]));
}
povrsina = abs(povrsina);
ll povrsine[n];
povrsine[0] = abs(povrsina - 0.5*(det(x[n-1],x[0], y[n-1], y[0]) + det(x[0], x[1],y[0],y[1])) + 0.5*(det(x[n-1],x[1],y[n-1],y[1])));
povrsine[n-1] = abs(povrsina - 0.5*(det(x[n-2],x[n-1], y[n-2], y[n-1]) + det(x[n-1], x[0], y[n-1],y[0])) + 0.5*(det(x[n-2],x[0],y[n-2],y[0])));
for( int i = 1; i < n-1; i++ ){
    povrsine[i] = abs(povrsina - 0.5*(det(x[i-1],x[i], y[i-1], y[i]) + det(x[i], x[i+1],y[i],y[i+1])) + 0.5*(det(x[i-1],x[i+1],y[i-1],y[i+1])));
}
for ( int i = 0; i < n; i++ ){
    cout << povrsine[i] << " ";
}
return 0;
}